-- Copyright (C) 1991-2010 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- Generated by Quartus II Version 10.1 Build 153 11/29/2010 SJ Full Version
-- Created on Sat Jan 29 08:58:57 2011

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY carrefour IS
    PORT (
        reset : IN STD_LOGIC := '0';
        clock : IN STD_LOGIC;
        voit_EO : IN STD_LOGIC := '0';
        BDT : IN STD_LOGIC_VECTOR(7 DOWNTO 0) := "00000000";
        or_cli : IN STD_LOGIC := '0';
        RAZ_CPT : OUT STD_LOGIC;
        R_NS : OUT STD_LOGIC;
        V_NS : OUT STD_LOGIC;
        R_EO : OUT STD_LOGIC;
        O_EO : OUT STD_LOGIC;
        V_EO : OUT STD_LOGIC;
        O_NS : OUT STD_LOGIC
    );
END carrefour;

ARCHITECTURE BEHAVIOR OF carrefour IS
    TYPE type_fstate IS (RAZ_T,NSO_EOR,NSV_EOR,NSR_EOR1,NSR_EOV,NSR_EOO,NSR_EOR2,OR1,RAZ_T2,OR0);
    SIGNAL fstate : type_fstate;
    SIGNAL reg_fstate : type_fstate;
BEGIN
    PROCESS (clock,reg_fstate)
    BEGIN
        IF (clock='1' AND clock'event) THEN
            fstate <= reg_fstate;
        END IF;
    END PROCESS;

    PROCESS (fstate,reset,voit_EO,BDT,or_cli)
    BEGIN
        IF (reset='1') THEN
            reg_fstate <= NSV_EOR;
            RAZ_CPT <= '0';
            R_NS <= '0';
            V_NS <= '0';
            R_EO <= '0';
            O_EO <= '0';
            V_EO <= '0';
            O_NS <= '0';
        ELSE
            RAZ_CPT <= '0';
            R_NS <= '0';
            V_NS <= '0';
            R_EO <= '0';
            O_EO <= '0';
            V_EO <= '0';
            O_NS <= '0';
            CASE fstate IS
                WHEN RAZ_T =>
                    reg_fstate <= NSO_EOR;

                    RAZ_CPT <= '1';

                    R_NS <= '0';

                    V_NS <= '1';

                    R_EO <= '1';

                    O_EO <= '0';

                    V_EO <= '0';

                    O_NS <= '0';
                WHEN NSO_EOR =>
                    IF ((BDT(7 DOWNTO 0) = "00000010")) THEN
                        reg_fstate <= NSR_EOR1;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= NSO_EOR;
                    END IF;

                    RAZ_CPT <= '0';

                    R_NS <= '0';

                    V_NS <= '0';

                    R_EO <= '1';

                    O_EO <= '0';

                    V_EO <= '0';

                    O_NS <= '1';
                WHEN NSV_EOR =>
                    IF ((or_cli = '1')) THEN
                        reg_fstate <= RAZ_T2;
                    ELSIF (((voit_EO = '1') AND NOT((or_cli = '1')))) THEN
                        reg_fstate <= RAZ_T;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= NSV_EOR;
                    END IF;

                    RAZ_CPT <= '0';

                    R_NS <= '0';

                    V_NS <= '1';

                    R_EO <= '1';

                    O_EO <= '0';

                    V_EO <= '0';

                    O_NS <= '0';
                WHEN NSR_EOR1 =>
                    IF ((BDT(7 DOWNTO 0) = "00000011")) THEN
                        reg_fstate <= NSR_EOV;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= NSR_EOR1;
                    END IF;

                    RAZ_CPT <= '0';

                    R_NS <= '1';

                    V_NS <= '0';

                    R_EO <= '1';

                    O_EO <= '0';

                    V_EO <= '0';

                    O_NS <= '0';
                WHEN NSR_EOV =>
                    IF ((BDT(7 DOWNTO 0) = "00001000")) THEN
                        reg_fstate <= NSR_EOO;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= NSR_EOV;
                    END IF;

                    RAZ_CPT <= '0';

                    R_NS <= '1';

                    V_NS <= '0';

                    R_EO <= '0';

                    O_EO <= '0';

                    V_EO <= '1';

                    O_NS <= '0';
                WHEN NSR_EOO =>
                    IF ((BDT(7 DOWNTO 0) = "00001010")) THEN
                        reg_fstate <= NSR_EOR2;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= NSR_EOO;
                    END IF;

                    RAZ_CPT <= '0';

                    R_NS <= '1';

                    V_NS <= '0';

                    R_EO <= '0';

                    O_EO <= '1';

                    V_EO <= '0';

                    O_NS <= '0';
                WHEN NSR_EOR2 =>
                    IF ((BDT(7 DOWNTO 0) = "00001011")) THEN
                        reg_fstate <= NSV_EOR;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= NSR_EOR2;
                    END IF;

                    RAZ_CPT <= '0';

                    R_NS <= '1';

                    V_NS <= '0';

                    R_EO <= '1';

                    O_EO <= '0';

                    V_EO <= '0';

                    O_NS <= '0';
                WHEN OR1 =>
                    IF ((BDT(7 DOWNTO 0) = "00000001")) THEN
                        reg_fstate <= OR0;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= OR1;
                    END IF;

                    O_EO <= '1';

                    O_NS <= '1';
                WHEN RAZ_T2 =>
                    IF ((or_cli = '1')) THEN
                        reg_fstate <= OR1;
                    ELSIF (NOT((or_cli = '1'))) THEN
                        reg_fstate <= NSV_EOR;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= RAZ_T2;
                    END IF;

                    RAZ_CPT <= '1';

                    R_NS <= '0';

                    V_NS <= '0';

                    R_EO <= '0';

                    O_EO <= '1';

                    V_EO <= '0';

                    O_NS <= '1';
                WHEN OR0 =>
                    IF ((BDT(7 DOWNTO 0) = "00000010")) THEN
                        reg_fstate <= RAZ_T2;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= OR0;
                    END IF;

                    O_EO <= '0';

                    O_NS <= '0';
                WHEN OTHERS => 
                    RAZ_CPT <= 'X';
                    R_NS <= 'X';
                    V_NS <= 'X';
                    R_EO <= 'X';
                    O_EO <= 'X';
                    V_EO <= 'X';
                    O_NS <= 'X';
                    report "Reach undefined state";
            END CASE;
        END IF;
    END PROCESS;
END BEHAVIOR;
