-- Copyright (C) 1991-2010 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- Generated by Quartus II Version 10.1 Build 153 11/29/2010 SJ Full Version
-- Created on Tue Dec 28 14:58:58 2010

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY compteur_MAE IS
    PORT (
        reset : IN STD_LOGIC := '0';
        clock : IN STD_LOGIC;
        sens : IN STD_LOGIC := '0';
        output1 : OUT STD_LOGIC;
        output2 : OUT STD_LOGIC
    );
END compteur_MAE;

ARCHITECTURE BEHAVIOR OF compteur_MAE IS
    TYPE type_fstate IS (state1,state3,state4,state2);
    SIGNAL fstate : type_fstate;
    SIGNAL reg_fstate : type_fstate;
BEGIN
    PROCESS (clock,reg_fstate)
    BEGIN
        IF (clock='1' AND clock'event) THEN
            fstate <= reg_fstate;
        END IF;
    END PROCESS;

    PROCESS (fstate,reset,sens)
    BEGIN
        IF (reset='1') THEN
            reg_fstate <= state1;
            output1 <= '0';
            output2 <= '0';
        ELSE
            output1 <= '0';
            output2 <= '0';
            CASE fstate IS
                WHEN state1 =>
                    IF ((sens = '1')) THEN
                        reg_fstate <= state2;
                    ELSIF (NOT((sens = '1'))) THEN
                        reg_fstate <= state4;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= state1;
                    END IF;

                    output1 <= '0';

                    output2 <= '0';
                WHEN state3 =>
                    IF (NOT((sens = '1'))) THEN
                        reg_fstate <= state2;
                    ELSIF ((sens = '1')) THEN
                        reg_fstate <= state4;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= state3;
                    END IF;

                    output1 <= '0';

                    output2 <= '1';
                WHEN state4 =>
                    IF ((sens = '1')) THEN
                        reg_fstate <= state1;
                    ELSIF (NOT((sens = '1'))) THEN
                        reg_fstate <= state3;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= state4;
                    END IF;

                    output1 <= '1';

                    output2 <= '1';
                WHEN state2 =>
                    IF (NOT((sens = '1'))) THEN
                        reg_fstate <= state1;
                    ELSIF ((sens = '1')) THEN
                        reg_fstate <= state3;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= state2;
                    END IF;

                    output1 <= '1';

                    output2 <= '0';
                WHEN OTHERS => 
                    output1 <= 'X';
                    output2 <= 'X';
                    report "Reach undefined state";
            END CASE;
        END IF;
    END PROCESS;
END BEHAVIOR;
