-- Copyright (C) 1991-2010 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- Generated by Quartus II Version 10.1 Build 153 11/29/2010 SJ Full Version
-- Created on Fri Jan 28 23:04:37 2011

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY motpp IS
    PORT (
        reset : IN STD_LOGIC := '0';
        clock : IN STD_LOGIC;
        DP : IN STD_LOGIC := '0';
        BA1 : OUT STD_LOGIC;
        BA2 : OUT STD_LOGIC;
        BB1 : OUT STD_LOGIC;
        BB2 : OUT STD_LOGIC
    );
END motpp;

ARCHITECTURE BEHAVIOR OF motpp IS
    TYPE type_fstate IS (P1,P2,P3,P4,P5,P6,P7,P8);
    SIGNAL fstate : type_fstate;
    SIGNAL reg_fstate : type_fstate;
BEGIN
    PROCESS (clock,reg_fstate)
    BEGIN
        IF (clock='1' AND clock'event) THEN
            fstate <= reg_fstate;
        END IF;
    END PROCESS;

    PROCESS (fstate,reset,DP)
    BEGIN
        IF (reset='1') THEN
            reg_fstate <= P1;
            BA1 <= '0';
            BA2 <= '0';
            BB1 <= '0';
            BB2 <= '0';
        ELSE
            BA1 <= '0';
            BA2 <= '0';
            BB1 <= '0';
            BB2 <= '0';
            CASE fstate IS
                WHEN P1 =>
                    IF ((DP = '1')) THEN
                        reg_fstate <= P2;
                    ELSIF (NOT((DP = '1'))) THEN
                        reg_fstate <= P3;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= P1;
                    END IF;

                    BA1 <= '0';

                    BA2 <= '0';

                    BB1 <= '0';

                    BB2 <= '1';
                WHEN P2 =>
                    reg_fstate <= P3;

                    BA1 <= '1';

                    BA2 <= '0';

                    BB1 <= '0';

                    BB2 <= '1';
                WHEN P3 =>
                    IF ((DP = '1')) THEN
                        reg_fstate <= P4;
                    ELSIF (NOT((DP = '1'))) THEN
                        reg_fstate <= P5;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= P3;
                    END IF;

                    BA1 <= '1';

                    BA2 <= '0';

                    BB1 <= '0';

                    BB2 <= '0';
                WHEN P4 =>
                    reg_fstate <= P5;

                    BA1 <= '1';

                    BA2 <= '1';

                    BB1 <= '0';

                    BB2 <= '0';
                WHEN P5 =>
                    IF ((DP = '1')) THEN
                        reg_fstate <= P6;
                    ELSIF (NOT((DP = '1'))) THEN
                        reg_fstate <= P7;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= P5;
                    END IF;

                    BA1 <= '0';

                    BA2 <= '1';

                    BB1 <= '0';

                    BB2 <= '0';
                WHEN P6 =>
                    reg_fstate <= P7;

                    BA1 <= '0';

                    BA2 <= '1';

                    BB1 <= '1';

                    BB2 <= '0';
                WHEN P7 =>
                    IF ((DP = '1')) THEN
                        reg_fstate <= P8;
                    ELSIF (NOT((DP = '1'))) THEN
                        reg_fstate <= P1;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= P7;
                    END IF;

                    BA1 <= '0';

                    BA2 <= '0';

                    BB1 <= '1';

                    BB2 <= '0';
                WHEN P8 =>
                    reg_fstate <= P1;

                    BA1 <= '0';

                    BA2 <= '0';

                    BB1 <= '1';

                    BB2 <= '1';
                WHEN OTHERS => 
                    BA1 <= 'X';
                    BA2 <= 'X';
                    BB1 <= 'X';
                    BB2 <= 'X';
                    report "Reach undefined state";
            END CASE;
        END IF;
    END PROCESS;
END BEHAVIOR;
