-- Copyright (C) 1991-2010 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- Generated by Quartus II Version 10.1 Build 153 11/29/2010 SJ Full Version
-- Created on Sat Jan 29 08:26:14 2011

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY gene_train_impusions IS
    PORT (
        reset : IN STD_LOGIC := '0';
        clock : IN STD_LOGIC;
        pulse : IN STD_LOGIC := '0';
        horloge : IN STD_LOGIC := '0';
        train : OUT STD_LOGIC
    );
END gene_train_impusions;

ARCHITECTURE BEHAVIOR OF gene_train_impusions IS
    TYPE type_fstate IS (state4,state1,state3,state2,state5);
    SIGNAL fstate : type_fstate;
    SIGNAL reg_fstate : type_fstate;
BEGIN
    PROCESS (clock,reg_fstate)
    BEGIN
        IF (clock='1' AND clock'event) THEN
            fstate <= reg_fstate;
        END IF;
    END PROCESS;

    PROCESS (fstate,reset,pulse,horloge)
    BEGIN
        IF (reset='1') THEN
            reg_fstate <= state5;
            train <= '0';
        ELSE
            train <= '0';
            CASE fstate IS
                WHEN state4 =>
                    reg_fstate <= state5;

                    train <= horloge;
                WHEN state1 =>
                    IF (NOT((pulse = '1'))) THEN
                        reg_fstate <= state2;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= state1;
                    END IF;

                    train <= '0';
                WHEN state3 =>
                    reg_fstate <= state4;

                    train <= horloge;
                WHEN state2 =>
                    reg_fstate <= state3;

                    train <= horloge;
                WHEN state5 =>
                    IF ((pulse = '1')) THEN
                        reg_fstate <= state1;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= state5;
                    END IF;

                    train <= '0';
                WHEN OTHERS => 
                    train <= 'X';
                    report "Reach undefined state";
            END CASE;
        END IF;
    END PROCESS;
END BEHAVIOR;
